/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    File Routines File

    This file supports the Basic Aggregate File Reading
    Functions needed in the Game.
*/
#define F_TRIMSPACE		1
#define F_IGNORESPACE 	2
#define F_IGNORETAB		4

char *ReadLine(FILE *Buffer, char *ReturnLine ,char Options) {
	int CurPos=0;
	char Response=0;
	int Status=0;
	char MetFirstChar=0;
	char GotIt=1;
	
	while (GotIt) {
		while (Response!='\n' && Status!=EOF) {
			Response = (char) (Status = fgetc(Buffer));
			if (Response!='\n' && Status!=EOF) {
				if (!(Response==' ' && (Options&F_TRIMSPACE) && (!MetFirstChar))) {
					if (!(Response==' ' && (Options&F_IGNORESPACE))) {
						if (!(Response=='\t' && (Options&F_IGNORETAB))) {
							*(ReturnLine+CurPos) = Response;
							CurPos++;
							MetFirstChar=1;
						};
					};
				};
			};
		};
		if (Status==EOF) {
			if (*(ReturnLine)!='#') {
				*(ReturnLine+CurPos)='\0';
				return(ReturnLine);
			} else {
				*(ReturnLine)='\0';
				return(ReturnLine);
			};
		}
		if (*(ReturnLine)=='#') {
			CurPos=0;
			Response=0;
			Status=0;
			MetFirstChar=0;
		} else GotIt=0;
	};
	*(ReturnLine+CurPos)='\0';
	
	return(ReturnLine);
};

char *PortReadLine(int FileDes, char *ReturnString, unsigned short int CurrentSize) {
	int CurPos =0;
	ssize_t Status =0;
	fd_set Read;
	
	FD_ZERO(&Read);
	FD_SET(FileDes, &Read);
	
	do {
		Status=read(FileDes,(ReturnString+CurPos),1);
		if (!Status) {
			//  Line Cut...
			select(FD_SETSIZE,&Read,NULL,NULL,NULL);
		} else
			if (Status==-1) {
				if (errno==EWOULDBLOCK) {
				 	// Line Cut...
					select(FD_SETSIZE,&Read,NULL,NULL,NULL);
				}
// Error in Connection  ** Warning No Implementation! /-/-/-///-///-/-/-/-/-/-/-/-
			} else {
				if (*(ReturnString+CurPos)!='\r') {
					CurPos++; 			// We got a character.
				};
			};
		if (CurPos==CurrentSize) {
			ReturnString = realloc(ReturnString,CurrentSize*2);
			CurrentSize=CurrentSize*2;
		};
	} while ( (*(ReturnString+CurPos-1)!='\n') );
	*(ReturnString+CurPos-1) = '\0';
	return(ReturnString);
};

void PortWriteLine(int FileDes, char *String) {
	int CurPos =0;
	int Length =strlen(String);
	ssize_t Status =0;
	fd_set Write;
	
	FD_ZERO(&Write);
	FD_SET(FileDes, &Write);
ReWrite:
	Status=write(FileDes,(String+CurPos),Length);
	if ((Status!=Length) && Status>=0) {
		//  Line Cut...
		select(FD_SETSIZE,NULL,&Write,NULL,NULL);
		CurPos+=Status;
		Length=Length-Status;
		goto ReWrite;
	};
// Error in Connection  ** Warning No Implementation! /-/-/-///-///-/-/-/-/-/-/-/-
	
	return;
};

void PortWriteData(char **Buffer, int *Length, char *Data, int DataLength) {
	int x;
	int Cur;

	Cur = strlen(*Buffer);
	for(x=0;x<DataLength;x++) {
		if (Cur>(*Length-4)) {
			(*Length)+=5;
			*Buffer = realloc(*Buffer,sizeof(char)*(*Length));
		};
		if (*(Data+x)=='\0') {
			*(*Buffer+Cur)=1;
			*(*Buffer+Cur+1)=2;
			Cur+=2;
		} else
			if (*(Data+x)=='\t') {
				*(*Buffer+Cur)=1;
				*(*Buffer+Cur+1)=3;
				Cur+=2;
			} else
				if (*(Data+x)=='\n') {
					*(*Buffer+Cur)=1;
					*(*Buffer+Cur+1)=4;
					Cur+=2;
				} else
					if (*(Data+x)==1) {
						*(*Buffer+Cur)=1;
						*(*Buffer+Cur+1)=1;
						Cur+=2;
					} else {
						*(*Buffer+Cur)=*(Data+x);
						Cur++;
					};
		
	};
	*(*Buffer+Cur)='\0';
};

void print(char *Message);

void PortWriteChar(char **Buffer, int *Length, char Char) {
	int Cur;

	if (strlen(*Buffer)>(*Length-5)) {
		(*Length)+=5;
		*Buffer = realloc(*Buffer,sizeof(char)*(*Length));
	};
	
	Cur = strlen(*Buffer);
	if (Char=='\0') {
		*(*Buffer+Cur)=1;
		*(*Buffer+Cur+1)=2;
		Cur+=2;
	} else
		if (Char=='\t') {
			*(*Buffer+Cur)=1;
			*(*Buffer+Cur+1)=3;
			Cur+=2;
		} else
			if (Char=='\n') {
				*(*Buffer+Cur)=1;
				*(*Buffer+Cur+1)=4;
				Cur+=2;
			} else
				if (Char==1) {
					*(*Buffer+Cur)=1;
					*(*Buffer+Cur+1)=1;
					Cur+=2;
				} else {
					*(*Buffer+Cur)=Char;
					Cur++;
				};
	*(*Buffer+Cur)='\0';				
};

void PortWriteSInt(char **Buffer, int *Length, short int Char) {
	PortWriteChar(Buffer,Length, (char) (Char>>8));
	PortWriteChar(Buffer,Length, (char) Char);
};
void PortWriteInt(char **Buffer, int *Length, int Char) {
	PortWriteChar(Buffer,Length, (char) (Char>>24));
	PortWriteChar(Buffer,Length, (char) (Char>>16));
	PortWriteChar(Buffer,Length, (char) (Char>>8));
	PortWriteChar(Buffer,Length, (char) Char);
};
void PortWriteString(char **Buffer, int *Length, char *String) {

	if ((strlen(String)+strlen(*Buffer))>(*Length-4)) {
		(*Length)+=(strlen(String)+strlen(*Buffer)+5)-(*Length);
		*Buffer = realloc(*Buffer,sizeof(char)*(*Length));
	};
	strcat(*Buffer, String);	
};
void PortWriteBufferClear(char *Buffer) {
	*Buffer='\0';
};
void PortWriteBufferFlush(char *Buffer, FILE *Socket) {
	fprintf(Socket, Buffer);
	fflush(Socket);
};