/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Game Server Main Module
		eecc++:
		MoveThread 				-- Processes the Movement Queue and modifies the Game World (accompanies attack)
		CommandProcessor		-- Processes the Command Queue and modifies the Game World
		ConnectionThread		-- Listens with the connection and sends the commands to the queue
		ConnectionManager		-- Listens to the specified port and invokes a new Connection Thread upon connection
+		Main Thread				-- Runs the Query Menu for the Administrator
		NewTurnSlaveThread	--
		NewTurnThread			-- Updates all of the data in Game World for the new turn.
		TurnManager				-- Waits for the next turn and calls NewTurnThread
+		Memory Display Manager  -- Sleeps and updates the memory display.
	
		eecc2X:
		This is the main server program.  It loops around waiting for
		connection requests.  And manages the query World Manager Thread.
	
		TD:
			-		

*/
#include <mss.h>
//#define MSS
#define 	DELAYS	0
#define  X1			B(1);H(1)
#define	Y1			B(0);H(0)
#define  THREADCOUNT		2
#include "errno.h"
#include "sys/socket.h"
#include "sys/types.h"
#include "netinet/in.h"				/* for htons				*/
#include "netdb.h"					/* for GetHostbyName		*/
#include "unistd.h"
#include "pthread.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "math.h"
#include "curses.h"

#include "GameSettings.gam"

//void *xrealloc(void *Prev, int Size);

//  Game Data Structures    *-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	#include "GameStructs.gam"
	
//  Game Flags for MutEx

	// NCurses Windows and Attributes
		int A_Norm, A_HOk, A_HErr, A_SysMesg, A_Prompt;
		short C_Temp;	
		WINDOW *Mesg, *Status, *InfoLine, *CommandLine;
		
	// Game Critical Flags
		char GCF_Terminate=0;
		char GCF_Close=0;
		char GCF_Critical=0;
		char GCF_Threads=0;

	// Location Flags --
		int CP_CurrentLocation;		// X|Y location of CommandProcessor
		int MT_CurrentLocation;		// X|Y location of Move Thread
	
	// MutEx Keys for CommandQueue and MovementQueue
		pthread_mutex_t MutEx_CQ = PTHREAD_MUTEX_INITIALIZER;
		pthread_mutex_t MutEx_MQ = PTHREAD_MUTEX_INITIALIZER;
		pthread_mutex_t M_Screen = PTHREAD_MUTEX_INITIALIZER;
		pthread_mutex_t M_Thread = PTHREAD_MUTEX_INITIALIZER;
		pthread_mutex_t M_Alloc = PTHREAD_MUTEX_INITIALIZER;

		// Command Queue
		short int CQ_Head = 0;
		short int CQ_Tail;
		short int CQ_Length;
		struct CQ *CommandQueue;
		
		// Movement Queue
		short int MQ_Head = 0;
		short int MQ_Tail;
		short int MQ_Length;
		struct MQ *MovementQueue;
		
	// MutEx for Game World
		pthread_mutex_t MutEx_GW = PTHREAD_MUTEX_INITIALIZER;
		pthread_mutex_t MutEx_GSD = PTHREAD_MUTEX_INITIALIZER;
		pthread_mutex_t MutEx_UnitIDo = PTHREAD_MUTEX_INITIALIZER;
		pthread_mutex_t MutEx_UnitIDe = PTHREAD_MUTEX_INITIALIZER;
      pthread_mutex_t M_APlayerSpace = PTHREAD_MUTEX_INITIALIZER;
      pthread_mutex_t M_IPlayerSpace = PTHREAD_MUTEX_INITIALIZER;
		
//  Game Global World    *-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	struct MapTile GameWorld[GW_WIDTH][GW_HEIGHT];
	struct GlobalServerData GameData;
	
	// Thread Switches
	char ConnMngr_NotifyOnConnect=CONN_MNGR_NOTIFY_ON_CONNECT;
	char NewConn_NotifyOnDisconnect=1;
	char NewConn_NotifyIdentity=NEW_CONN_NOTIFY_IDENTITY;

//  Main Global Variables   *-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	// Game Data!
		unsigned char GSD_MaxSight;
		unsigned short int GW_CurrentTurn=0;
		unsigned short int *HT_UnitIDo=NULL;
		unsigned short int HT_UnitIDoLen=0;
		unsigned short int *HT_UnitIDe=NULL;
		unsigned short int HT_UnitIDeLen=0;
		int GSD_ConnectPort;

	// Threads
		pthread_attr_t attr;		// The universal detached and
		pthread_t T_InfoLine;
		pthread_t T_ConnMngr;

//  Game Utility Section	 *-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	#include "GameDataQueryRoutines.c"
	#include "FileRoutines.c"
	#include "UtilityFunctions.c"
	#include "MapQueryRoutines.c"
	#include "PlayerRoutines.c"
	#include "APlayerRelations.c"
	#include "GameInitRoutines.c"
	#include "ServerCommand.c"
	
//  Game Threads Section    *-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	//#include "TMoveThread.c"
	//#include "TCommandProcessor.c"
	#include "TOldPlayer.c"
	#include "TConnectionManager.c"

int main(void) {

	char Response='c';
	char *StringBuffer;
	FILE *FileBuffer;
	int x;
	time_t timex;
	
	srand(time(&timex));
	
//	MSS_DISABLE_LOG_OUTPUT;

		
	// Main Inititalization
	StringBuffer = malloc(sizeof(char)*100);
	if (StringBuffer==NULL) {
		perror("Out of Memory [INIT:STRBUFFER]");
		exit(1);
	};
	for(x=0;x<=99;x++) *(StringBuffer+x) = '\0';

	
	//    N Curses Initialization Routine
   NCursesInit();

	// Game Initialization   (Screen with main window)
	GameInit(StringBuffer);	
	while (GCF_Threads!=1);
	
	print("\nGame Preparations Done.");Ok();N();N();
	D_Status("Load an Existing Game or Create a New One?");
	Response = AskLetter("Create New Game (y/n)?","YynN");
	
	if (strchr("Yy",Response)) {
	   NewGameInit(StringBuffer, FileBuffer);
	   	
	} else {
		print("Loading Old Game:");
	};
	
	//  Actual Game Threads Setup
	D_Status("Starting Manager Game Threads...");
	if (DELAYS) sleep(2);
		// Command Queue Processor Thread
		// Movement Queue Processor Thread
		// Connection Manager Thread
		if (pthread_attr_setstacksize(&attr, (PTHREAD_STACK_MIN/*+0x500*/))) {endwin();printf("01x1");exit(1);};
		if (pthread_create(&T_ConnMngr,&attr,ThreadConnectionManager,(void*) &x)) {endwin();printf("01e");exit(1);};
		
		
		// Turn Manager Thread
	
	while (GCF_Threads!=THREADCOUNT)
   	if (GCF_Critical) {
   		break;
	   }

  	if (GCF_Critical) {
   	D_Status("GAME CRITICAL ERROR REPORTED!  Server Unstartable!");
	   beep();print("\n\nThread Reported Errors.  Game Cannot Start!");Err();getch();
  		GCF_Close=1;		
   }	   		
		
	//  CommandLine Interpreter
	while (!GCF_Close) {
		D_Status("Server On-Line.  Enter Command.                  (type help for help)");
		COMMAND_MAIN(StringBuffer);
	};
	
	

	N();GCF_Terminate=1;
	// Game Server Shutdown
	D_Status("Server Shutdown.  Freeing All Resources...");
	
/*	
	if (!GCF_Critical) {
		// Connect to Self & send kill.
		ServerSocketKill();
	
		print("\nStopping all Threads...\n");
		while (GCF_Threads!=0) sleep(1);
	};
//  */	
	
	
	if (DELAYS) sleep(1);
		// Joining all Threads
		// Freeing all Game Memory
			free(StringBuffer);
		
			// Queue Memory
			B(1);N();print("Freeeing Queues...        ");B(0);N();
				// Command Queue Removal
				B(1);print("    [Command Queue]   ");B(0);
				if (pthread_mutex_lock(&MutEx_CQ)) {endwin();perror("CQ Master Lock");exit(1);};
				print(" [Lock] ");
				free(CommandQueue);
				if (DELAYS)	sleep(1);
				H(1);print(" [OK] ");H(0);
				if (pthread_mutex_unlock(&MutEx_CQ)) {endwin();perror("CQ Master Unlock");exit(1);};
				print(" [Unlock] ");
			N();		
				// Movement Queue Removal
				B(1);print("    [Movement Queue]  ");B(0);
				if (pthread_mutex_lock(&MutEx_MQ)) {endwin();perror("MQ Master Lock");exit(1);};
				print(" [Lock] ");
				free(MovementQueue);
				if (DELAYS)	sleep(2);
				H(1);print(" [OK] ");H(0);
				if (pthread_mutex_unlock(&MutEx_MQ)) {endwin();perror("MQ Master Unlock");exit(1);};
				print(" [Unlock] ");
			N();N();
				
		// Freeing all Locks
		B(1);print("Freeeing Locks...         ");B(0);N();
		if (DELAYS) sleep(1);
			// Movement MutEx
				print("   [Movement Queue Lock]");
			if (pthread_mutex_destroy(&MutEx_MQ)) {endwin();perror("MQ Master Destroy");exit(1);};
				Ok();N();
			// Command MutEx
				print("   [Command Queue Lock]");
			if (pthread_mutex_destroy(&MutEx_CQ)) {endwin();perror("CQ Master Destroy");exit(1);};
				Ok();N();
			// Game World MutEx
				print("   [Game World Lock]");
			if (pthread_mutex_destroy(&MutEx_GW)) {endwin();perror("GW Master Destroy");exit(1);};
				Ok();N();
			// Thread Count MutEx
				print("   [Thread Count Lock]");
			if (pthread_mutex_destroy(&M_Thread)) {endwin();perror("Thread Master Destroy");exit(1);};
				Ok();N();
			// Screen MutEx
				print("   [Screen Lock]");
			if (pthread_mutex_destroy(&M_Screen)) {endwin();perror("Screen Master Destroy");exit(1);};
				Ok();N();
		N();N();			
		
		// Freeing all Thread attributes
	D_Status("Shutdown Done.  Press any key to exit.");getch();
	endwin();
}