/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Player Common Routines
	
		eecc2X:
		This file contains most of the functions to enable player data
		modifications regardless of Activity.
		
		eecc++
	
		TD:

*/

char NotifyTileChange(unsigned char x, unsigned char y);


/*                                SHORTHAND DATA ACCESS FOR PLAYERS
*******************************************************************        */

signed char SearchAPlayer(char *UserName) {
	struct ActivePlayer *Active = GameData.ActivePlayers;
	unsigned char NoActive = GameData.NoActivePlayers;
	unsigned char CurPos = 0;
	
	while (CurPos<NoActive) {
		if ((*(Active+CurPos)).Code!=0)
			if (!strcmp( (*(Active+CurPos)).UserName, UserName) ) {
				return(CurPos);
			};
		CurPos++;
	};
	return(-1);
}

signed char SearchIPlayer(char *UserName) {
	struct InactivePlayer *Inactive = GameData.InactivePlayers;
	unsigned char NoInactive = GameData.NoInactivePlayers;
	unsigned char CurPos = 0;
	
	while (CurPos<NoInactive) {
		if ((*(Inactive+CurPos)).Code!=0)
			if (!strcmp( (*(Inactive+CurPos)).UserName, UserName) ) {
				return(CurPos);
			};
		CurPos++;
	};
	return(-1);
}

char SearchIPlayer_Code(unsigned short int Codex) {
	struct InactivePlayer *Inactive = GameData.InactivePlayers;
	unsigned char CurPos = 0;
	
	while (CurPos<GameData.NoInactivePlayers) {
		if ((*(Inactive+CurPos)).Code == Codex ) {
			return(1);
		};
		CurPos++;
	};
	return(0);
}

char SearchAPlayer_Code(unsigned short int Codex) {
	struct ActivePlayer *Active = GameData.ActivePlayers;
	unsigned char CurPos = 0;
	
	while (CurPos<GameData.NoActivePlayers) {
		if ((*(Active+CurPos)).Code == Codex ) {
			return(1);
		};
		CurPos++;
	};
	return(0);
}

struct ActivePlayer *GetAPlayer(unsigned short int Code) {
	struct ActivePlayer *ReturnData = NULL;
	int x = 0;
	
	ReturnData=GameData.ActivePlayers;
	while (x<GameData.NoActivePlayers) {
		if (ReturnData->Code == Code) return(ReturnData);
		ReturnData++;
	   x++;
	};
	return(NULL);
};

struct InactivePlayer *GetIPlayer(unsigned short int Code) {
	struct InactivePlayer *ReturnData = NULL;
	int x = 0;
	
	ReturnData=GameData.InactivePlayers;
	while (x<GameData.NoInactivePlayers) {
		if (ReturnData->Code == Code) return(ReturnData);
		ReturnData++;
	   x++;
	};
	return(NULL);
};


char *GetPlayerUserName(unsigned short int Code) {
	char *UserName;
	struct ActivePlayer *AP;
	struct InactivePlayer *IP;
	
	
	UserName=xalloc(sizeof(char)*10);
	if ((AP=GetAPlayer(Code))!=NULL) {
		strcpy(UserName, AP->UserName);
	} else
		if ((IP=GetIPlayer(Code))!=NULL) {
			strcpy(UserName, IP->UserName);
		} else {
		   free(UserName);
		   return(NULL);		
		};
	return(UserName);
};

short int FreePlayerCode(void) {
	unsigned short int Return;
	char notOK = 1;
	               		
	while (notOK) {
		Return = rand()%9999;
		if (!SearchIPlayer_Code(Return)) {
			if (!SearchAPlayer_Code(Return)) {
				notOK=0;
			};
		};	
	};
	return(Return);
};







/*                                      QUEUE MANAGEMENT FOR PLAYER
*******************************************************************        */

char AddPlayerThreadQueue(struct ActivePlayer *Player, unsigned char x, unsigned char y, unsigned char MessageType, unsigned int Data) {
	unsigned char Top;
	
	Top = Player->ThreadQueueTop;
//x-print("q");
	pthread_mutex_lock(&MutEx_GSD);
//x-print("w");
	if (Player->ThreadQueueLength<=Top) {
//x-print("e");
		(Player->ThreadQueueLength)+=2;
		Player->ThreadQueue = realloc(Player->ThreadQueue, (Player->ThreadQueueLength)*sizeof(struct ThreadQueue));
//x-print("r");
	}
	(Player->ThreadQueue+Top)->X = x;
//x-print("t");
	(Player->ThreadQueue+Top)->Y = y;
//x-print("y");
	(Player->ThreadQueue+Top)->MessageType = MessageType;
//x-print("u");
	(Player->ThreadQueue+Top)->data = Data;
//x-print("i");
	(Player->ThreadQueueTop)++;
//x-print("o");
	pthread_mutex_unlock(&MutEx_GSD);
	return(0);
};





/*                                       LIST MANAGEMENT FOR PLAYER
*******************************************************************        */

struct Bases *EnlargeBList(unsigned char *Len, struct Bases *List, char Size) {
	struct Bases *New;
	
	if ((New = realloc(List, sizeof(struct Base)*(*Len+Size)))== NULL) {
		fprintf(stderr,"!1! -- EnlargeBList]   Cannot allocate memory.\n");
		return(NULL);
	};
	(*Len) = *Len +Size;
	return(New);
};

char AddBList(unsigned char *Len, struct Bases **List, unsigned char x, unsigned char y, char *Name) {
	struct Bases *New, *Mover;

	pthread_mutex_lock(&MutEx_GSD);
	if ((New = EnlargeBList(Len, *List, 1)) != NULL) {
		Mover = (New + (*Len) - 1);
		Mover->X = x;
		Mover->Y = y;
		strcpy(Mover->Name, Name);
		*List = New;
		pthread_mutex_unlock(&MutEx_GSD);
		return(0);
	};
	pthread_mutex_unlock(&MutEx_GSD);
	return(1);
};

char DeleteBList(unsigned char *Len, struct Bases **List, unsigned char Position) {
	struct Bases *Mover;
	int x = 0;
	
	pthread_mutex_lock(&MutEx_GSD);
	Mover=*List;
	x=Position+1;
	Mover = Mover+Position+1;
	while (x<(*Len)) {
		(Mover-1)->X=Mover->X;		
		(Mover-1)->Y=Mover->Y;
		Mover++;
		x++;
	};
	Mover = realloc(Mover,sizeof(struct Bases)*((*Len)-1));
	*List = Mover;
	pthread_mutex_unlock(&MutEx_GSD);
	return(0);
};

char DisplayBList(unsigned char *Len, struct Listing *List) {
	
};



/*  Listing Modification Functions    */
struct Listing *EnlargeList(unsigned char *Len, struct Listing *List, char Size) {
	struct Listing *New;
	
	if ((New = realloc(List, sizeof(struct Listing)*(*Len+Size)))== NULL) {
		fprintf(stderr,"!1! -- EnlargeList]   Cannot allocate memory.\n");
		return(NULL);
	};
	(*Len) = *Len +1;
	return(New);
};


char AddList(unsigned char *Len, struct Listing **List, unsigned char x, unsigned char y) {
	struct Listing *New, *Mover;

	pthread_mutex_lock(&MutEx_GSD);
	if ((New = EnlargeList(Len, *List, 1)) != NULL) {
		Mover = (New + *Len - 1);
		Mover->X = x;
		Mover->Y = y;
		*List = New;
		pthread_mutex_unlock(&MutEx_GSD);
		return(0);
	};
	pthread_mutex_unlock(&MutEx_GSD);
	return(1);
};

char DeleteList(unsigned char *Len, struct Listing **List, unsigned char Position) {
	struct Listing *Mover;
	int x = 0;
	
	pthread_mutex_lock(&MutEx_GSD);
	Mover=*List;
	x=Position+1;
	Mover = Mover+Position+1;
	while (x<(*Len)) {
		(Mover-1)->X=Mover->X;		
		(Mover-1)->Y=Mover->Y;
		Mover++;
		x++;
	};
	Mover = realloc(Mover,sizeof(struct Listing)*((*Len)-1));
	*List = Mover;
	pthread_mutex_unlock(&MutEx_GSD);
	return(0);
};

char DisplayList(unsigned char *Len, struct Listing *List) {
	
};






/*                                         DATA CREATION FOR PLAYER
*******************************************************************        */

char CreateUnit(unsigned char x, unsigned char y, unsigned short int Owner, unsigned char UnitType, char mode) {  // Modes:  0-NewProdUnit  1-NewPlayerUnit
	struct ActivePlayer *Player;
	unsigned short int Temp;
	void *UnitChunk, **B4UnitChunk;
	struct UnitData *Blank = NULL;
	struct UnitDataTable *UnitData;
	char rx,ry;
	char Cntr;
	
	// Check Tile Validity.
		// Less than 8 units
		if (UnitCount(x,y)>=8) return(-11);
		// No Opponent in Tile
		Temp = GetTileOwner(x,y);
		if (Temp!=0 && Temp!=Owner) return(-10);
		// No Trap in Tile.
		if (GameWorld[x][y].IsTrapped) return(-9);
	// Update Player Lists
print("z");	
	if ( (Player = GetAPlayer(Owner)) == NULL ) return(-8);
print("|1|");	
	if ( AddList(&(Player->UnitCounter), &(Player->Unit), x, y) ) return(-7);
print("|2|");	
	Temp = HT_UnitID_Get();
print("|3|");	
	// Create Actual Tile Data
	UnitChunk = GetUnitChunk(x,y);
		// Find Blank
print("y");	
		if (UnitChunk==NULL) {
		fprintf(stderr,"1");
			B4UnitChunk = (void **) GetB4UnitChunk(x,y);
		fprintf(stderr,"2");
	      pthread_mutex_lock(&MutEx_GW);
		fprintf(stderr,"3");
	      UnitChunk = xalloc(sizeof(struct Unit1));
		fprintf(stderr,"4");
	      ((struct Unit1 *) UnitChunk)->Next = *B4UnitChunk;
	      ((struct Unit1 *) UnitChunk)->ChunkType = 5;
	      ((struct Unit1 *) UnitChunk)->Player = Owner;	
	      *B4UnitChunk = UnitChunk;
		print("5");
			Blank = &(((struct Unit1 *) UnitChunk)->Units[0]);
	      pthread_mutex_unlock(&MutEx_GW);		
	      // Ready for adding
		} else if (((struct Unit1 *) UnitChunk)->ChunkType==5) {
				if (((struct Unit1 *) UnitChunk)->Units[0].UnitID==0) { // Empty Unit1
			      ((struct Unit1 *) UnitChunk)->Player = Owner;
					Blank = &(((struct Unit1 *) UnitChunk)->Units[0]);
				} else {
					// Upgrade size from 1 to 4
					B4UnitChunk = (void **) GetB4UnitChunk(x,y);
	   		   pthread_mutex_lock(&MutEx_GW);
			      UnitChunk = realloc(UnitChunk, sizeof(struct Unit4));
	      		((struct Unit4 *) UnitChunk)->ChunkType = 6;
				   *B4UnitChunk = UnitChunk;
	      		// Blank out the mem.
	      		((struct Unit4 *) UnitChunk)->Units[1].UnitID = 0;
	      		((struct Unit4 *) UnitChunk)->Units[2].UnitID = 0;
	      		((struct Unit4 *) UnitChunk)->Units[3].UnitID = 0;
					Blank = &(((struct Unit4 *) UnitChunk)->Units[1]);
			      pthread_mutex_unlock(&MutEx_GW);					
				};
			} else if (((struct Unit1 *) UnitChunk)->ChunkType==6) {
					Blank = NULL;
					for (Cntr=0;Cntr<4;Cntr++)
						if (((struct Unit4 *) UnitChunk)->Units[Cntr].UnitID==0)
							Blank = &(((struct Unit4 *) UnitChunk)->Units[Cntr]);					
					if (Blank==NULL) { // Full  Unit4
						// Upgrade size from 4 to 8
						B4UnitChunk = (void **)GetB4UnitChunk(x,y);
	   		   	pthread_mutex_lock(&MutEx_GW);
				      UnitChunk = realloc(UnitChunk, sizeof(struct Unit8));
		      		((struct Unit8 *) UnitChunk)->ChunkType = 7;
					   *B4UnitChunk = UnitChunk;
	      			// Blank out the mem.
	      			((struct Unit8 *) UnitChunk)->Units[5].UnitID = 0;
	      			((struct Unit8 *) UnitChunk)->Units[6].UnitID = 0;
		      		((struct Unit8 *) UnitChunk)->Units[7].UnitID = 0;
						Blank = &(((struct Unit8 *) UnitChunk)->Units[4]);
				      pthread_mutex_unlock(&MutEx_GW);					
					};					
				} else {
					Blank = NULL;
					for (Cntr=0;Cntr<8;Cntr++)
						if (((struct Unit8 *) UnitChunk)->Units[Cntr].UnitID==0)
							Blank = &(((struct Unit8 *) UnitChunk)->Units[Cntr]);			
				};
	// Blank Found... Now Enter the Data
print("x");	
	GameWorld[x][y].HasUnits=1;
   pthread_mutex_lock(&MutEx_GW);					
	Blank->Type = UnitType;
	Blank->GroupID = 0;
	Blank->UnitID = Temp;
	UnitData = GetUnitData(UnitType);
	Blank->Life = UnitData->Life;
	if (mode==0) {
		Blank->Moves = 0;
		Blank->Turns = GW_CurrentTurn;
	} else {
		if (mode==1) {
			Blank->Moves = 0;
			if ((GW_CurrentTurn-GW_NEWTURNS)<0) {
				Blank->Turns = 65000+(GW_CurrentTurn-GW_NEWTURNS);
			} else Blank->Turns = GW_CurrentTurn-GW_NEWTURNS;		
		};
	};	
   pthread_mutex_unlock(&MutEx_GW);
	
	// Update Sight
print("w");	
	for(rx=-UnitData->SightRange;rx<=UnitData->SightRange;rx++)
		for(ry=-UnitData->SightRange;ry<=UnitData->SightRange;ry++) {
			if ( sqrt(pow((double)ry,2) + pow((double)rx,2)) <= ((double) UnitData->SightRange) ) {
				AddSight(rx+x, ry+y, Player);
			};
		}

	// Update Player Monetary Info
print("v");	
   pthread_mutex_lock(&MutEx_GSD);
	if ( (Player = GetAPlayer(Owner)) == NULL ) return(-5);
	Player->Upkeep+=(UnitData->UpkeepCost)*10;
   pthread_mutex_unlock(&MutEx_GSD);

   // Notify Other Players!
print("u");	
	NotifyTileChange(x,y);
print("t");	

	
   return(0);
};



char CreateBase(unsigned char x, unsigned char y, unsigned short int Owner,  char Level, unsigned char Prod, char *Name) {
	struct ActivePlayer *Player;
	unsigned short int Temp;
	struct Base *New;
	struct Base **B4;
	char rx,ry;
	char Display[30];

	// Check Tile
		// Previous Base
		if (GameWorld[x][y].HasBase) return(-11);
print("<1>");		
		// Other Structures  (Set,Rad,Bar)
		if (GameWorld[x][y].HasBuilding) return(-10);
print("<2>");		
		// Other Tile Owner
		Temp = GetTileOwner(x,y);
print("<3>");		
		if (Temp!=0 && Temp!=Owner) return(-9);
	// Add to Player List
	if ( (Player = GetAPlayer(Owner)) == NULL ) return(-8);
print("<4>");		
	if ( AddBList(&(Player->BaseCounter), &(Player->Base), x, y, Name) ) return(-7);
print("<5>");		
	// Add the Base Chunk
	New = malloc(sizeof(struct Base));
print("<6>");		
	New->ChunkType = 10;
print("<7>");		
	New->Player = Owner;
print("<8>");		
	New->Level = Level;
print("<9>");		
	if (Prod) {
		New->IsManufacturing = 1;
		New->Type = Prod;
		New->QuantityLeft=0;
		New->ProductionLeft = (GetUnitData(Prod))->CostProduction;
	} else {
		New->IsManufacturing = 0;
		New->ProductionLeft = 0;
		New->QuantityLeft = 0;
		New->Type = 0;
	}
print("<10>");		
	New->ExcessTurnPoints = 0;
print("<11>");		
	New->Evolution = GameData.BaseData[Level].Evolution*10;
	pthread_mutex_lock(&MutEx_GW);
print("<12>");		
	B4 = GetB4BaseChunk(x,y);
print("<13>");
	New->Next = (void *) *B4;
	*B4 = New;
	
	if ((*B4)!=NULL) {
		sprintf(Display,"---|%d|---",(*B4)->ChunkType);
		print(Display);
	};
	
	// Change Map Flags
	GameWorld[x][y].HasBase = 1;
	pthread_mutex_unlock(&MutEx_GW);
	// Add Sight
print("<14>");		
	for(rx=-(GW_BASESIGHTRANGE);rx<=GW_BASESIGHTRANGE;rx++)
		for(ry=-(GW_BASESIGHTRANGE);ry<=GW_BASESIGHTRANGE;ry++) {
			if ( sqrt(pow((double)ry,2) + pow((double)rx,2)) <= ((double) GW_BASESIGHTRANGE) ) {
				AddSight(rx+x, ry+y, Player);
			};
		}
	// Update Monetary Info
print("<15>");		
	pthread_mutex_lock(&MutEx_GSD);
	if ( (Player = GetAPlayer(Owner)) == NULL ) return(-8);	
	Player->Upkeep+=GameData.BaseData[Level].Upkeep*100;
	pthread_mutex_unlock(&MutEx_GSD);
   // Notify Other Players!
	if (GameWorld[x][y].Data!=NULL) {
		sprintf(Display,"---|%d|---",((struct Sight2 *) GameWorld[x][y].Data)->ChunkType);
		print(Display);
	};
print("<16>");		
	NotifyTileChange(x,y);
print("<17>");		
	return(0);
};



char CreateSettlement(unsigned char x, unsigned char y, unsigned short int Owner,  char Level, char *Name) {
	struct ActivePlayer *Player;
	unsigned short int Temp;
	struct Settlement *New;
	struct Settlement **B4;
	char rx,ry;

	// Check Tile
		// Previous Base
		if (GameWorld[x][y].HasBase) return(-11);
//x-print(".");
		// Other Structures  (Set,Rad,Bar)
		if (GameWorld[x][y].HasBuilding) return(-10);
		// Other Tile Owner
		Temp = GetTileOwner(x,y);
//x-print("1");
		if (Temp!=0 && Temp!=Owner) return(-9);
	// Add to Player List
	if ( (Player = GetAPlayer(Owner)) == NULL ) return(-8);
//x-print(".");
	if ( AddBList(&(Player->SettlementCounter), &(Player->Settlement), x, y, Name) ) return(-7);
	// Add the Base Chunk
	New = malloc(sizeof(struct Settlement));
//x-print("2");
	New->ChunkType = 9;
	New->Level = Level;
//x-print(".");
	New->Player = Owner;
	New->IsRedAlert = 0;
//x-print("3");
	New->FundingFocus = 0;
	New->Evolution = GameData.SettlementData[Level].Evolution*100;
//x-print(".");
	pthread_mutex_lock(&MutEx_GW);
	B4 = GetB4SettlementChunk(x,y);
//x-print("4");
	New->Next = (void *) *B4;
	*B4 = New;
	// Change Map Flags
	GameWorld[x][y].HasBuilding = 1;
	pthread_mutex_unlock(&MutEx_GW);
	// Add Sight
	for(rx=-(GW_SETTLEMENTSIGHTRANGE);rx<=GW_SETTLEMENTSIGHTRANGE;rx++)
		for(ry=-(GW_SETTLEMENTSIGHTRANGE);ry<=GW_SETTLEMENTSIGHTRANGE;ry++) {
			if ( sqrt(pow((double)ry,2) + pow((double)rx,2)) <= ((double) GW_SETTLEMENTSIGHTRANGE) ) {
				AddSight(rx+x, ry+y, Player);
			};
		}
//x-print("5");
	// Update Monetary Info
	pthread_mutex_lock(&MutEx_GSD);
	if ( (Player = GetAPlayer(Owner)) == NULL ) return(-8);	
	Player->Income+=GameData.SettlementData[Level].Upkeep*100;
	pthread_mutex_unlock(&MutEx_GSD);
//x-print(".");
   // Notify Other Players!
	NotifyTileChange(x,y);
//x-print("6");
	return(0);
};