/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
		Server Command Functions
	
		eecc2X:
      This file does the actual translation and the work with every
      Server Command Entered.
			
		TD:
			Help	- Displays the Help Listing
			Exit  - Shutdowns the Server.

*/

char MapFoggedVisible(unsigned char x, unsigned char y, struct ActivePlayer *Player);
char MapSightVisible(unsigned char x, unsigned char y, unsigned short int Code);


void COM_Help(void) {
	print("Print Help\n\n");getch();
	
	return;
}

char COM_LActivePlayers(void) {
	struct ActivePlayer *Mover;
	unsigned char x;
	char *Temp = malloc(sizeof(char)*80);
	
	H(1);print("-=List of Active Players=-");N();H(0);
	Mover = GameData.ActivePlayers;
	for(x=0;x<GameData.NoActivePlayers;x++,Mover++) {
		if (Mover->Code!=0) {
			sprintf(Temp,"    %3d %-30s    %-10s\n",x+1,Mover->Name,Mover->UserName);
			print(Temp);
		};
	};
	N();
	free(Temp);
	return(1);

};

char COM_DisplayMap(char *String) {
	char *Input[4];
	int x;
	
	if (NTokenize(" ",Input,(String+11),4)<4) {
		B(1);print("  Insufficient Parameters:\n   Usage: DisplayMap Xtop Ytop Xbot Ybot\n");B(0);
		return(0);
	}
	DisplayWorld(atoi(Input[0]),atoi(Input[1]),atoi(Input[2]),atoi(Input[3]));
	for(x=0;x<4;x++) free(Input[x]);
	return(1);
};

char COM_DisplayPlayer(char *String) {
	char *Temp;
	struct ActivePlayer *Player;
	unsigned short int Code;
	int x;
	int y=0;
	int z;
	int *Hash;
	int HashCounter;
	struct Unit1 *Tempx;
	struct Base *TempB;
	struct Settlement *TempS;

	for(x=0;(x<GameData.NoActivePlayers && strcmp(((GameData.ActivePlayers)+x)->UserName, String));x++);

	if (strcmp(((GameData.ActivePlayers)+x)->UserName, String)) {
		B(1);print("  User Not Found in Active List.\n");B(0);
		return(0);
	};
	Temp = malloc(200);
	Player = ((GameData.ActivePlayers)+x);
	Code = ((GameData.ActivePlayers)+x)->Code;
	
	B(1);H(1);print(" Player Data:\n");B(0);H(0);
	sprintf(Temp,"   %-30s   [%-8s][%-15s]     |%5d|\n   $:%9d         ^:%6d           <IN:%6d\n   Bases: (%d)\n",Player->Name,Player->UserName,Player->Password,Player->Code,Player->Money,Player->Upkeep,Player->Income,Player->BaseCounter);
	print(Temp);
	// List Bases!
	if (Player->BaseCounter) {
		y=0;
		while ( y<(Player->BaseCounter) ) {
			if ((TempB = GetBaseChunk( (((Player->Base)+y)->X), (((Player->Base)+y)->Y) ))!=NULL) {
				sprintf(Temp,"    (%3d,%3d)   %-15s       |%d|Ev:%d\n       %d->(%d)     Q:%3d   PLft:%4d   ExT:%3d\n",(((Player->Base)+y)->X), (((Player->Base)+y)->Y),(((Player->Base)+y)->Name),TempB->Player,TempB->Evolution,TempB->IsManufacturing,TempB->Type,TempB->QuantityLeft,TempB->ProductionLeft,TempB->ExcessTurnPoints);
				print(Temp);
			};
			y++;
		};
	};
	
	sprintf(Temp,"   Units: (%d)\n",Player->UnitCounter);
	print(Temp);
	// List Units!
	if (Player->UnitCounter) {
		y=0;
		HashPrepare(&Hash,&HashCounter, (Player->UnitCounter+1), 0x1ffff, 0x2ffff);
		while ( y<(Player->UnitCounter) ) {
			z= ((((Player->Unit)+y)->X) << 8) + (((Player->Unit)+y)->Y);
			if (!HashEntry(&Hash, &HashCounter, 0x1ffff, 0x2ffff, z)) {
				if ((Tempx = GetUnitChunk( (((Player->Unit)+y)->X), (((Player->Unit)+y)->Y) ))!=NULL) {
					if (Tempx->ChunkType==5) {
						if (Tempx->Units[0].UnitID!=0) {
							sprintf(Temp,"    (%3d,%3d)   [%6d]   (%3d)  %2d|%-6d    L:%6d   M:%4.1f|%6ld\n",(((Player->Unit)+y)->X),(((Player->Unit)+y)->Y),Tempx->Player,Tempx->Units[0].Type, Tempx->Units[0].GroupID, Tempx->Units[0].UnitID, Tempx->Units[0].Life, (Tempx->Units[0].Moves)/10, (int) Tempx->Units[0].Turns);
							print(Temp);
						};
					} else if (Tempx->ChunkType==6) {
						for(z=0;z<4;z++)
							if (((struct Unit4 *) Tempx)->Units[z].UnitID!=0) {
								sprintf(Temp,"    (%3d,%3d)   [%6d]   (%3d)  %2d|%-6d    L:%6d   M:%4.1f|%6ld\n",(((Player->Unit)+y)->X),(((Player->Unit)+y)->Y),((struct Unit4 *) Tempx)->Player,((struct Unit4 *) Tempx)->Units[z].Type, ((struct Unit4 *) Tempx)->Units[z].GroupID, ((struct Unit4 *) Tempx)->Units[z].UnitID, ((struct Unit4 *) Tempx)->Units[z].Life, (((struct Unit4 *) Tempx)->Units[z].Moves)/10, (int) ((struct Unit4 *) Tempx)->Units[z].Turns);
								print(Temp);
							};					
						} else {
							for(z=0;z<8;z++)
								if (((struct Unit8 *) Tempx)->Units[z].UnitID!=0) {
									sprintf(Temp,"    (%3d,%3d)   [%6d]   (%3d)  %2d|%-6d    L:%6d   M:%4.1f|%6ld\n",(((Player->Unit)+y)->X),(((Player->Unit)+y)->Y),((struct Unit8 *) Tempx)->Player,((struct Unit8 *) Tempx)->Units[z].Type, ((struct Unit8 *) Tempx)->Units[z].GroupID, ((struct Unit8 *) Tempx)->Units[z].UnitID, ((struct Unit8 *) Tempx)->Units[z].Life, (((struct Unit8 *) Tempx)->Units[z].Moves)/10, (int) ((struct Unit8 *) Tempx)->Units[z].Turns);
									print(Temp);
								};					
						};
				};				
			};
			y++;
		};
		free(Hash);
	};
	sprintf(Temp,"   Settlements: (%d)\n",Player->SettlementCounter);
	print(Temp);
	// List Settlements!
	if (Player->SettlementCounter) {
		y=0;
		while ( y<(Player->SettlementCounter) ) {
			if ((TempS = GetSettlementChunk( (((Player->Settlement)+y)->X), (((Player->Settlement)+y)->Y) ))!=NULL) {
				sprintf(Temp,"    (%3d,%3d)   %-15s       |%d|Ev:%d|   Lvl:%d (RA!:%d) F:%d\n",(((Player->Settlement)+y)->X), (((Player->Settlement)+y)->Y),(((Player->Settlement)+y)->Name),TempS->Player,TempS->Evolution,TempS->Level,TempS->IsRedAlert,TempS->FundingFocus);
				print(Temp);
			};
			y++;
		};
	};	
	sprintf(Temp,"   Traps: (%d)\n",Player->TrapCounter);
	print(Temp);
	// List Traps!
	if (Player->TrapCounter) { };
	sprintf(Temp,"   Barriers: (%d)\n",Player->BarrierCounter);
	print(Temp);
	// List Barriers!
	if (Player->BarrierCounter) { };	
	N();	
	free(Temp);
	return(1);
};

char COM_PlayerList(void) {
	short int x;

	N();H(1);B(1);print(" Active Players List:\n");B(0);H(0);
	for(x=0;x<GameData.NoActivePlayers;x++) {printx("   ");print(((GameData.ActivePlayers)+x)->UserName);N();};
	N();
	return(1);

};

void COM_Exit(void) {
	char Response;	
	
	D_Status("Shutdown the Game Server?  This will stop all connections.");
	Response = AskLetter("Terminate Game Server? (y/n)?","YynN");
	
	if (strchr("Yy",Response)) {
		D_Status("Initializing Server Shutdown....");
		print("\n    **ShutDown Server Initiated...\n\n");
		GCF_Close=1;
		return;
	}
	print("\n    **Request Ignored.  Server still Online...\n\n");
	return;
}

char COM_MapVisible(char *StringBuffer) {
	char *Temp;
	int Code;
	unsigned char x,y;
	
	Temp = malloc(200);
	Code = atoi(StringBuffer+8);
	*(StringBuffer+3)='\0';
	*(StringBuffer+7)='\0';
	x = atoi(StringBuffer);
	y = atoi(StringBuffer+4);
	
	sprintf(Temp, "(%3d,%3d) [%4d]  (%d)(%d)\n", x,y,Code,(GetSightChunk ? "1":"0"),MapSightVisible(x,y,Code));
	print(Temp);
	free(Temp);
	return(1);
};

void COMMAND_MAIN(char *StringBuffer) {
   char CommandOk;

	CommandOk = 0;
	StringBuffer=GetCommand(StringBuffer,100);
	if (!strcasecmp("help",StringBuffer)) {
		COM_Help();
		CommandOk=1;
	};
	if (!strcasecmp("exit",StringBuffer)) {
		COM_Exit();
		CommandOk=1;
	};
	if (!strncasecmp("List",StringBuffer,4)) {
		if (!strcasecmp("List ActivePlayers",StringBuffer)) CommandOk = COM_LActivePlayers();
	};
	if (!strcasecmp("Refresh",StringBuffer)) {
		refreshall();
		CommandOk=1;
	}
	if (!strncasecmp("DisplayMap ",StringBuffer,11)) {
		CommandOk = COM_DisplayMap(StringBuffer);
		refreshall();
	}
	if (!strncasecmp("DisplayPlayer ",StringBuffer,14)) {
		CommandOk = COM_DisplayPlayer(StringBuffer+14);
		refreshall();
	}
	if (!strncasecmp("PlayerList",StringBuffer,10)) {
		CommandOk = COM_PlayerList();
		refreshall();
	}
	if (!strncasecmp("MapVisible",StringBuffer,10)) {
		CommandOk = COM_MapVisible(StringBuffer+11);
		refreshall();
	}		
	if (!strncasecmp("VarMod ConnMngr_NotifyOnConnect 0",StringBuffer,33)) {
		ConnMngr_NotifyOnConnect=0;
		CommandOk=1;
	};
	if (!strncasecmp("VarMod ConnMngr_NotifyOnConnect 1",StringBuffer,33)) {
		ConnMngr_NotifyOnConnect=1;
		CommandOk=1;
	};
	if (!strncasecmp("VarMod NewConn_NotifyIdentity 0",StringBuffer,31)) {
		NewConn_NotifyIdentity=0;
		CommandOk=1;
	};
	if (!strncasecmp("VarMod NewConn_NotifyIdentity 1",StringBuffer,31)) {
		NewConn_NotifyIdentity=1;
		CommandOk=1;
	};
	if (!CommandOk) {
		beep();
	}
}