/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Game Support Functions
    Utility Functions

*/

/*                                                MEMORY ALLOCATION
*******************************************************************        */
void print(char *string);
void Err(void);
void N(void);

void *xalloc(int Size) {
	void *Return;
	
	pthread_mutex_lock(&M_Alloc);
//	printf(".");
	if ((Return = malloc(Size))==NULL) {
		print("       -[Xalloc]  Memory Consumed or memory allocation error!");Err();N();
		beep();beep();
		sleep(3);
		fprintf(stderr,"Out of Memory or Memory allocation error.\n");
		exit(1);	
	};
//	printf("+");
	pthread_mutex_unlock(&M_Alloc);
	return(Return);
}

void *xxrealloc(void *Prev, int Size) {
	void *Return;
	
	pthread_mutex_lock(&M_Alloc);
//	print("(");
	if ((Return = realloc(Prev, Size))==NULL) {
		print("       -[Xalloc]  Memory Consumed or memory allocation error!");Err();N();
		beep();beep();
		sleep(3);
		fprintf(stderr,"Out of Memory or Memory allocation error.\n");
		exit(1);	
	};
//	print(")");
	pthread_mutex_unlock(&M_Alloc);
	return(Return);
}

/*                                                  THREAD FLAGGING
*******************************************************************        */

void ThreadCountDecrement(void) {
	pthread_mutex_lock(&M_Thread);
	GCF_Threads--;
	pthread_mutex_unlock(&M_Thread);
};

void ThreadCountIncrement(void) {
	pthread_mutex_lock(&M_Thread);
	GCF_Threads++;
	pthread_mutex_unlock(&M_Thread);
};






/*                                             STRING MANIPULATIONS
*******************************************************************        */

char *strtrim(char *String) {
	int x=0;
	int CurPos=0;
	
	while((*(String+x)==' ')) x++;
	if (x>0) {
		while((*(String+x)!='\0')) {
			*(String+CurPos) = *(String+x);
			x++;
			CurPos++;
		};
		*(String+CurPos)='\0';
	} else while (*(String+CurPos)!='\0') CurPos++;
	CurPos--;
	while((*(String+CurPos)==' ')) CurPos--;
	CurPos++;
	*(String+CurPos)='\0';
	return(String);
}

int Tokenize(char *Divider, char **Output, char *String) {
	int x=0;
	char *Token;

	Token = strtok(String,Divider);
	while (Token!=NULL) {
		*(Output+x) = strdup(Token);
		x++;
		Token = strtok(NULL,Divider);	
	}
	return(x);
};

int NTokenize(char *Divider, char **Output, char *String, char MaxIn) {
	int x=0;
	char *Token;
	
	Token = strtok(String,Divider);
	while (x<MaxIn && Token!=NULL) {
		*(Output+x) = strdup(Token);
		x++;
		Token = strtok(NULL,Divider);	
	}
	return(x);
};

long ConvString(char *String) {
	char CurPos=0;
	char Position=0;
	long ReturnValue=0;
	char Digit;
	
	// Go To End of String
	while (*(String+CurPos)!='\0') CurPos++;
	CurPos--;
	
	// While Not in the Beginning
	while (CurPos!=-1) {
		if (isdigit(*(String+CurPos))) {
			Digit = *(String+CurPos)-48;
			ReturnValue += Digit*(pow(10.0,Position));
			Position++;
		}
		CurPos--;
	}
	return(ReturnValue);
}

char *Padl(char *Source, char *Target, int Length) {
	int SourceLen, CurPos;
	
	strcpy(Target, Source);
	CurPos = SourceLen = strlen(Source);
	while (CurPos<Length) {
		*(Target+CurPos) = ' ';
		CurPos++;
	};
	*(Target+CurPos) = '\0';
	return(Target);
};









/*                                           SERVER SCREEN PRINTING
*******************************************************************        */

void refreshall(void) {
   pthread_mutex_lock(&M_Screen);
	refresh();
	wrefresh(InfoLine);
	wrefresh(Status);
	wrefresh(Mesg);
	wrefresh(CommandLine);
   pthread_mutex_unlock(&M_Screen);
};

void D_Status(char *Message) {
   pthread_mutex_lock(&M_Screen);
	wclear(Status);
	mvwprintw(Status,0,3,"%s",Message);
   pthread_mutex_unlock(&M_Screen);
	refreshall();
};

void print(char *string) {
   pthread_mutex_lock(&M_Screen);
	wprintw(Mesg,"%s",string);
   pthread_mutex_unlock(&M_Screen);
	refreshall();
};

void printx(char *string) {
   pthread_mutex_lock(&M_Screen);
	wprintw(Mesg,"%s",string);
   pthread_mutex_unlock(&M_Screen);
};

void printr(char *string) {
	int y,x;

   pthread_mutex_lock(&M_Screen);	
	getyx(Mesg,y,x);
	mvwprintw(Mesg,y,COLS-strlen(string),"%s",string);
   pthread_mutex_unlock(&M_Screen);
	refreshall();
};

void B(char state) {
   pthread_mutex_lock(&M_Screen);	
	if (state) {
		wattron(Mesg,A_BOLD);
	} else {
		wattroff(Mesg,A_BOLD);
	};
   pthread_mutex_unlock(&M_Screen);	
};

void H(char state) {
   pthread_mutex_lock(&M_Screen);	
	if (state) {
		wattron(Mesg,COLOR_PAIR(COLOR_CYAN));
	} else {
		wattroff(Mesg,COLOR_PAIR(COLOR_CYAN));
	};
   pthread_mutex_unlock(&M_Screen);	
};

void N(void) {
   pthread_mutex_lock(&M_Screen);	
	wprintw(Mesg,"\n");
   pthread_mutex_unlock(&M_Screen);	
};

void Ok(void) {
	int y,x;

   pthread_mutex_lock(&M_Screen);	
	getyx(Mesg,y,x);
	wattron(Mesg, A_BOLD|A_REVERSE|COLOR_PAIR(COLOR_GREEN));
	mvwprintw(Mesg,y,COLS-7,"[ Ok ]");
	wattroff(Mesg, A_BOLD|A_REVERSE|COLOR_PAIR(COLOR_GREEN));
   pthread_mutex_unlock(&M_Screen);	
	refreshall();
}

void Err(void) {
	int y,x;

   pthread_mutex_lock(&M_Screen);	
	getyx(Mesg,y,x);
	wattron(Mesg, A_BOLD|A_REVERSE|COLOR_PAIR(COLOR_RED));
	mvwprintw(Mesg,y,COLS-10,"[ Error ]");
	wattroff(Mesg, A_BOLD|A_REVERSE|COLOR_PAIR(COLOR_RED));
   pthread_mutex_unlock(&M_Screen);	
	refreshall();
}







/*                                                 BIT MANIPULATION
*******************************************************************        */

char BitGet(char data, char Position) {
	data = data>>(7-Position);
	data = data & 1;
	return(data);
}

char SBitGet(unsigned short int data, char Position) {
	data = data>>(15-Position);
	data = data & 1;
	return(data);
}

char XBitGet(int data, char Position) {
	data = data>>(31-Position);
	data = data & 1;
	return(data);
}

char BitStore(char data, char Bit, char Position) {
	char Comparser = Bit;
	char Special;

	Comparser = Comparser<<(7-Position);
	Special = 1;
	Special = Special<<(7-Position);
	if (BitGet(data, Position)) {   // if the bit is 1
		Comparser = ~Comparser;
		Comparser = Comparser ^ Special;
		return(data & Comparser);
	} else 	// if the bit is 0
		return(data ^ Comparser);
}

unsigned short int SBitStore(unsigned short int data, char Bit, char Position) {
	unsigned short int Comparser = Bit;
	unsigned short int Special;

	Comparser = Comparser<<(15-Position);
	Special = 1;
	Special = Special<<(15-Position);
	if (SBitGet(data, Position)) {   // if the bit is 1
		Comparser = ~Comparser;
		Comparser = Comparser ^ Special;
		return(data & Comparser);
	} else 	// if the bit is 0
		return(data ^ Comparser);
}

unsigned int XBitStore(unsigned int data, char Bit, char Position) {
	unsigned int Comparser = Bit;
	unsigned int Special;

	Comparser = Comparser<<(31-Position);
	Special = 1;
	Special = Special<<(31-Position);
	if (SBitGet(data, Position)) {   // if the bit is 1
		Comparser = ~Comparser;
		Comparser = Comparser ^ Special;
		return(data & Comparser);
	} else 	// if the bit is 0
		return(data ^ Comparser);
}

char SwapBits(char Letter) {
	char Temp;
	
	Temp = BitGet(Letter,0);
	Letter = BitStore(Letter, BitGet(Letter,7), 0);
	Letter = BitStore(Letter, Temp, 7);

	Temp = BitGet(Letter,1);
	Letter = BitStore(Letter, BitGet(Letter,6), 1);
	Letter = BitStore(Letter, Temp, 6);

	Temp = BitGet(Letter,2);
	Letter = BitStore(Letter, BitGet(Letter,5), 2);
	Letter = BitStore(Letter, Temp, 5);

	Temp = BitGet(Letter,3);
	Letter = BitStore(Letter, BitGet(Letter,4), 3);
	Letter = BitStore(Letter, Temp, 4);

	return(Letter);
};






/*                               GENERAL HASH TABLES IMPLEMENTATION
*******************************************************************        */

char HashPrepare(int **Start, int *Len, int Size, int Blank, int LastElem) {
	int x=0;

	*Start = malloc(Size*sizeof(int));
	*Len = Size;
	
	for(x=0;x<Size-1;x++) *(*Start+x) = Blank;
	*(*Start+x)=LastElem;
	return(0);
};

char HashEntry(int **Start, int *Len, int Blank, int LastElem, int Data) {
	int x=0;
	int Spare=-1;
	
	while ((*(*Start+x)!=LastElem)) {
		if (Data==*(*Start+x)) return(1);
		if ((*(*Start+x)==Blank) && Spare==-1) Spare=x;
		x++;
	};
	if (Spare==-1) {
		if (x<*Len-1) {
			*(*Start+x)=Data;
			*(*Start+x+1)=LastElem;			
		} else {
			*Start = realloc(*Start,((*Len)+5)*sizeof(int));
			*Len+=5;
			*(*Start+x)=Data;
			*(*Start+x+1)=LastElem;
		};
	} else {
		*(*Start+Spare)=Data;
	};
	return(0);
};







/*                                                   SERVER PROMPTS
*******************************************************************        */

char AskLetter(char *Prompt, char *Choices) {
	char Response='\1';
	
	printx("    => ");
	wattron(Mesg, A_BOLD|COLOR_PAIR(COLOR_CYAN));
	printx(Prompt);
	wattroff(Mesg, A_Prompt);
	print(" ");
	while (!strchr(Choices,(int) Response)) {
		Response=(char) getch();
		if (!strchr(Choices,(int) Response))
			beep();
	};
	wattron(Mesg, A_Prompt);
	waddch(Mesg,toupper(Response));
	wattroff(Mesg, A_Prompt);
	refreshall();Ok();
	return(Response);
}

char *AskString(char *StringBuffer, char *Default, char MaxLen) {
	char Response='\0';
	char CurPos=0;
	
	echo();wattron(Mesg,A_Prompt);
	wgetnstr(Mesg,StringBuffer,MaxLen);noecho();wattroff(Mesg,A_Prompt);
	if (strlen(StringBuffer)==0) strcpy(StringBuffer,Default);
	return(StringBuffer);
}

char *GetCommand(char *StringBuffer, char MaxLen) {
	char Response='\0';
	char CurPos=0;

	*(StringBuffer)='\0';
	while (strlen(StringBuffer)<=0) {	
		mvwprintw(CommandLine,0,1,"COMMAND> ");
		echo();wattron(CommandLine,A_Prompt);
		wgetnstr(CommandLine,StringBuffer,MaxLen);noecho();wattroff(CommandLine,A_Prompt);
	};
	wclear(CommandLine);N();refreshall();	
	return(StringBuffer);
}






/*                                               MEMORY SPACE QUERY
*******************************************************************        */

long MemFree(void) {
	char MemoryString[12];
	long ReturnValue;
	FILE *MemInfo;
	
	if ((MemInfo=fopen("/proc/meminfo","r"))==NULL) {
		print("\n    **Error in trying to open memory information!");Err();
		return(0);
	};
	if (fseek(MemInfo,186,SEEK_SET)==-1) {
		print("\n    **Error in trying to seek memory information!");Err();
		fclose(MemInfo);
		return(0);
	};
	MemoryString[11]='\0';
	if (!fread(MemoryString,11,1,MemInfo)) {
		print("\n    **Error while trying to read memory information!");Err();
		fclose(MemInfo);
		return(0);
	};
	ReturnValue = ConvString(MemoryString);
	fclose(MemInfo);
	return(ReturnValue);
};

long MemSwapFree(void) {
	char MemoryString[12];
	long ReturnValue;
	FILE *MemInfo;
	
	if ((MemInfo=fopen("/proc/meminfo","r"))==NULL) {
		print("\n    **Error in trying to open memory information!");Err();
		return(0);
	};
	if (fseek(MemInfo,301,SEEK_SET)==-1) {
		print("\n    **Error in trying to seek memory information!");Err();
		fclose(MemInfo);
		return(0);
	};
	MemoryString[11]='\0';
	if (!fread(MemoryString,11,1,MemInfo)) {
		print("\n    **Error while trying to read memory information!");Err();
		fclose(MemInfo);
		return(0);
	};
	ReturnValue = ConvString(MemoryString);
	fclose(MemInfo);
	return(ReturnValue);
};







/*                                                    MISCELLANEOUS
*******************************************************************        */

char *Encrypt(char *String) {
	int CurPos = 0;
	
	while (*(String+CurPos)!='\0') {
		*(String+CurPos) = SwapBits(*(String+CurPos));
		CurPos++;
	};
   return(String);
};

void DisplayWorld(unsigned char xtop, unsigned char ytop, unsigned char xbot, unsigned char ybot) {
	unsigned char x,y;
	char TerrainDisplay[TERRAINTYPES];
	char *Temp = malloc(200);
	
	TerrainDisplay[TPLAIN] = TERRAINDISPLAY_PLAIN;
	TerrainDisplay[TMOUNTAIN] = TERRAINDISPLAY_MOUNTAIN;
	TerrainDisplay[THILL] = TERRAINDISPLAY_HILL;
	TerrainDisplay[TJUNGLE] = TERRAINDISPLAY_JUNGLE;
	TerrainDisplay[TSWAMP] = TERRAINDISPLAY_SWAMP;
	TerrainDisplay[TGRASSLAND] = TERRAINDISPLAY_GRASSLAND;
	TerrainDisplay[TSEA] = TERRAINDISPLAY_SEA;
	
	sprintf(Temp,"\nGame World at [%d,%d] to [%d,%d]:\n",xtop,ytop,xbot,ybot);
	print(Temp);
	for(y=ytop;y<=ybot;y++) {
		for(x=xtop;x<=xbot;x++) {
			sprintf(Temp, "%c" ,TerrainDisplay[GameWorld[x][y].Terrain]);printx(Temp);
		};
		N();
	};
	refreshall();
	free(Temp);
}

void ServerSocketKill(void) {
   struct sockaddr_in sa;
   char myname[30];
   struct hostent *hp;
   int s, NewS;

	print("       -[ServSockKill]  Sending Shutdown message to Connection Thread...\n");
   memset(&sa, 0, sizeof(struct sockaddr_in)); 	/* clear our address */
	gethostname(myname, 30);           	/* who are we? */
	hp= gethostbyname(myname);                  	/* get our address info */
	if (hp == NULL) {                             	/* we don't exist !? */
		printx("       -[ServSockKill]  Cannot Identify Self!");Err();N();
		return;
   };
	sa.sin_family= hp->h_addrtype;             	/* this is our host address */
	sa.sin_port= htons(4621);                		/* this is our port number */
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) { 		/* create socket */
		printx("       -[ServSockKill]  Cannot Create Socket!");Err();N();
		return;
	};
	if ((NewS = connect(s,(struct sockaddr *) &sa,sizeof(struct sockaddr_in))) < 0) {
		printx("       -[ServSockKill]  Cannot Connect to Socket!");Err();N();
		return;
	};
	close(NewS);
	close(s);
	print("       -[ServSockKill]  Shutdown message sent to Connection Thread!");Ok();N();
	return;
}
